# RightTree

Right Plant Right Place Right Time implementation using React and Django.

## Running application for development
### Initial Setup

Before running the applications please ensure the following prerequisites have been met.
#### Software
Most applications in this repository are built using Docker which resolves many dependencies but you will require a local installation of `git`, `docker` and `docker-compose`.

```bash
$ sudo apt install git docker-compose
```

To install `docker`, follow the [official installation documentation](https://docs.docker.com/get-docker/). [Instructions are also available for `docker-compose`](https://docs.docker.com/compose/install/).

#### Initialise database

Creates `right_tree` database and installs `postgis` extensions.

```
chmod +x ./database/init_database.sh
./database/init_database.sh
```

#### Initial build

Builds the Django backend docker image. This may need to be re-run if any new dependencies are added.
```
docker-compose build
```

### Run web application

Starts up the applications including the frontend, backend and database.

```
docker-compose up
```

Once running the components can be accessed as follows:

| Application | Hosted |
| --- | --- |
| React Frontend | http://localhost:3000 |
| Django Backend | http://localhost:8000 |
| Database | postgis://localhost:5432 |